[Setting hidden]
string S_SkinName = "";
string sn = S_SkinName;

bool ChangesApplied = false;
bool LastIsError = false;

CSystemFidsFolder@ GetFolderByName(CSystemFidsFolder@ Folder, const string&in Name)
{
    for (uint i = 0; i < Folder.Trees.Length; i++)
    {
        auto FolderOut = cast<CSystemFidsFolder>(Folder.Trees[i]);
        if (tostring(FolderOut.DirName) == Name)
        {
            return FolderOut;
        }
    }
    return null;
}

CSystemFidFile@ GetFileByName(CSystemFidsFolder@ Folder, const string&in Name)
{
    for (uint i = 0; i < Folder.Leaves.Length; i++)
    {
        auto FileOut = cast<CSystemFidFile>(Folder.Leaves[i]);
        if (tostring(FileOut.FileName) == Name)
        {
            return FileOut;
        }
    }
    return null;
}

void ApplyChanges()
{
    CSystemFidsFolder@ ProfileFolder = null;
    auto UserFolder = Fids::GetUserFolder("");
    int Counter = 0;
    while (ProfileFolder is null)
    {
        for (uint i = 0; i < UserFolder.Trees.Length; i++)
        {
            auto Folder = cast<CSystemFidsFolder>(UserFolder.Trees[i]);
            if (Regex::IsMatch(Folder.DirName, ".{8}-.{4}-.{4}-.{4}-.{12}"))
            {
                @ProfileFolder = @Folder;
                break;
            }
        }
        if (++Counter >= 10)
        {
            LastIsError = true;
            return;
        }
    }
    Fids::UpdateTree(ProfileFolder);
    auto ProfileGbxFolder = GetFolderByName(ProfileFolder, "Profile");
    CSystemFidFile@ ProfileGbx = null;
    while (ProfileGbx is null)
    {
        @ProfileGbx = GetFileByName(ProfileGbxFolder, "Profile.Gbx");
    }
    auto ProfileNod = cast<CGameUserProfile>(Fids::Preload(ProfileGbx));
    try 
    {
        ProfileNod.SkinName = S_SkinName;
        LastIsError = false;
        ChangesApplied = true;
    } 
    catch 
    {
        LastIsError = true;
    }
}

void Main() { return; }

void Render()
{
    UI::Begin("\\$0FD" + Icons::Car + " " + Icons::PaintBrush + " \\$zSkinnerTurbo");

    string Skinname = UI::InputText("Skin name", sn);
    sn = Skinname;

    if (UI::Button("Apply changes " + "\\$0FD" + Icons::Car + " " + Icons::PaintBrush))
    {
        S_SkinName = Skinname;
        ApplyChanges();
    }

    if (ChangesApplied)
    {
        UI::Text("\\$f00" + Icons::ExclamationTriangle + " \\$zReboot the game to view changes.");
    }
    if (LastIsError)
    {
        UI::Text("\\$f00" + Icons::ExclamationTriangle + " \\$zAn error occured. Please only apply changes after getting past the intro.");
    }

    UI::End();
}